//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// DBG.H
//
//		DEBUG definitions.
//
//		Developed using MSVC 5.0.
//
//	Bill Alexander
//	10/13/98
//
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#define HF_ENTRY				0x00000001
#define HF_EXIT				0x00000002
#define HF_ENTRY_PARAMS		0x00000004
#define HF_EXIT_PARAMS		0x00000008
#define HF_INTERNAL			0x00000010
#define MF_ENTRY				0x00000100
#define MF_EXIT				0x00000200
#define MF_ENTRY_PARAMS		0x00000400
#define MF_EXIT_PARAMS		0x00000800
#define MF_INTERNAL			0x00001000
#define LF_ENTRY				0x00010000
#define LF_EXIT				0x00020000
#define LF_ENTRY_PARAMS		0x00040000
#define LF_EXIT_PARAMS		0x00080000
#define LF_INTERNAL			0x00100000
#define DB_REGS_READ			0x10000000
#define DB_REGS_WRITE		0x20000000
#define DB_CUR_DB				0x40000000
#define DB_ALWAYS				0x80000000

#define DB_ALL					0xFFFFFFFF
#define DB_ENTRY				HF_ENTRY | MF_ENTRY | LF_ENTRY
#define DB_EXIT				HF_EXIT | MF_EXIT | LF_EXIT
#define DB_ERROR				DB_ALWAYS

#ifdef DEBUG

	#define DEBUGFLAGS DebugFlags

	#ifdef _VXD_MAIN_MODULE_

		DWORD DebugFlags =			DB_ALWAYS | DB_ERROR | DB_CUR_DB;
		DWORD DebugThisRoutine =	DB_ALL;

	#else

		#ifdef _DLL_MAIN_MODULE_

			DWORD DebugFlags =			DB_ALWAYS | DB_ERROR | DB_CUR_DB;
			DWORD DebugThisRoutine =	DB_ALL;

		#else

			#ifdef _APP_MAIN_MODULE_

				DWORD DebugFlags =			DB_ALWAYS | DB_ERROR | DB_CUR_DB;
				DWORD DebugThisRoutine =	DB_ALL;

			#else

				extern DWORD DebugFlags;
				extern DWORD DebugThisRoutine;

			#endif

		#endif

	#endif

	#ifdef _VXD_

		#define DBBREAK {if(DEBUGFLAGS&(DB_ERROR)){_asm int 1}}
		#define DBOUT(f,s) {if(DEBUGFLAGS&(f)) LCODE__Debug_Printf_Service(s);}
		#define DBOUT1(f,s,p1) {if(DEBUGFLAGS&(f)) LCODE__Debug_Printf_Service(s,p1);}
		#define DBOUT2(f,s,p1,p2) {if(DEBUGFLAGS&(f)) LCODE__Debug_Printf_Service(s,p1,p2);}
		#define DBOUT3(f,s,p1,p2,p3) {if(DEBUGFLAGS&(f)) LCODE__Debug_Printf_Service(s,p1,p2,p3);}
		#define DBOUT4(f,s,p1,p2,p3,p4) {if(DEBUGFLAGS&(f)) LCODE__Debug_Printf_Service(s,p1,p2,p3,p4);}
		#define DBOUT5(f,s,p1,p2,p3,p4,p5) {if(DEBUGFLAGS&(f)) LCODE__Debug_Printf_Service(s,p1,p2,p3,p4,p5);}

	#else

		#pragma warning (disable:4005)
		#define DBBREAK {if(DEBUGFLAGS&(DB_ERROR)){_asm int 3}}
		#define DBOUT(f,s) {if(DEBUGFLAGS&(f)) Debug_Printf_Service0(s);}
		#define DBOUT1(f,s,p1) {if(DEBUGFLAGS&(f)) Debug_Printf_Service1(s,(DWORD)p1);}
		#define DBOUT2(f,s,p1,p2) {if(DEBUGFLAGS&(f)) Debug_Printf_Service2(s,(DWORD)p1,(DWORD)p2);}
		#define DBOUT3(f,s,p1,p2,p3) {if(DEBUGFLAGS&(f)) Debug_Printf_Service3(s,(DWORD)p1,(DWORD)p2,(DWORD)p3);}
		#define DBOUT4(f,s,p1,p2,p3,p4) {if(DEBUGFLAGS&(f)) Debug_Printf_Service4(s,(DWORD)p1,(DWORD)p2,(DWORD)p3,(DWORD)p4);}
		#define DBOUT5(f,s,p1,p2,p3,p4,p5) {if(DEBUGFLAGS&(f)) Debug_Printf_Service5(s,(DWORD)p1,(DWORD)p2,(DWORD)p3,(DWORD)p4,(DWORD)p5);}
		void Debug_Printf_Service0 (char *s)
		{
			OutputDebugString (s);
			if (pi.VerbosityLevel >= VL_DEBUG)
				printf (s);
		}
		void Debug_Printf_Service1 (char *s, DWORD p1)
		{
			char msg[500];
			sprintf (msg, s, p1);
			OutputDebugString (msg);
			if (pi.VerbosityLevel >= VL_DEBUG)
				printf (s, p1);
		}
		void Debug_Printf_Service2 (char *s, DWORD p1, DWORD p2)
		{
			char msg[500];
			sprintf (msg, s, p1, p2);
			OutputDebugString (msg);
			if (pi.VerbosityLevel >= VL_DEBUG)
				printf (s, p1, p2);
		}
		void Debug_Printf_Service3 (char *s, DWORD p1, DWORD p2, DWORD p3)
		{
			char msg[500];
			sprintf (msg, s, p1, p2, p3);
			OutputDebugString (msg);
			if (pi.VerbosityLevel >= VL_DEBUG)
				printf (s, p1, p2, p3);
		}
		void Debug_Printf_Service4 (char *s, DWORD p1, DWORD p2, DWORD p3, DWORD p4)
		{
			char msg[500];
			sprintf (msg, s, p1, p2, p3 ,p4);
			OutputDebugString (msg);
			if (pi.VerbosityLevel >= VL_DEBUG)
				printf (s, p1, p2, p3, p4);
		}
		void Debug_Printf_Service5 (char *s, DWORD p1, DWORD p2, DWORD p3, DWORD p4, DWORD p5)
		{
			char msg[500];
			sprintf (msg, s, p1, p2, p3 ,p4, p5);
			OutputDebugString (msg);
			if (pi.VerbosityLevel >= VL_DEBUG)
				printf (s, p1, p2, p3, p4, p5);
		}

	#endif

#else

	#define DBBREAK
	#define DBOUT(f,s)
	#define DBOUT1(f,s,p1)
	#define DBOUT2(f,s,p1,p2)
	#define DBOUT3(f,s,p1,p2,p3)
	#define DBOUT4(f,s,p1,p2,p3,p4)
	#define DBOUT5(f,s,p1,p2,p3,p4,p5)

#endif
