/*--------------------------------------------------------------------------*/
/* Filename:    snapshot.h                                                  */
/* Description: Header file for snapshot.c                                  */
/*                                                                          */
/* http://www.seqadvtech.com                                                */
/*--------------------------------------------------------------------------*/
/* (C) Copyright 1996-1997 by Sequoia Advanced Technologies, Inc.           */
/* All Rights Reserved.                                                     */
/*--------------------------------------------------------------------------*/
/* Digital Data Port is a trademark of Sequoia Advanced Technologies, Inc.  */
/* PCILynx is a trademark of Texas Instruments Corporation                  */
/*--------------------------------------------------------------------------*/

BOOL AutoWhiteBalance(cls1394HANDLE hDev);
BOOL AllocateChannel(cls1394HANDLE hDev, PULONG lpChannel);
BOOL AllocateBandwidth(cls1394HANDLE hDev, PULONG lpSpeed, 
                       PULONG lpBytesPerFrame, PHANDLE lphBandwidth);
BOOL AllocateResources(cls1394HANDLE hDev, DWORD dwSpeed, DWORD dwFlags,
                       PHANDLE lphResources);
BOOL AttachBuffers(cls1394HANDLE hDev, HANDLE hResources, DWORD Channel,
                   PISOCH_DESCRIPTOR lpIsochDescriptor);
BOOL IsochListen(cls1394HANDLE hDev, HANDLE hResources, DWORD Channel);
BOOL FreeChannel(cls1394HANDLE hDev, DWORD Channel);
BOOL FreeBandwidth(cls1394HANDLE hDev, HANDLE hBandwidth);
BOOL FreeResources(cls1394HANDLE hDev, HANDLE hResources);
BOOL WriteQuadlet(cls1394HANDLE hDev, LARGE_INTEGER liAddress, QUADLET qValue);
BOOL IsochStop(cls1394HANDLE hDev, HANDLE hResources, DWORD Channel);
BOOL DetachBuffers(cls1394HANDLE hDev, HANDLE hResources,
                   PISOCH_DESCRIPTOR lpIsochDescriptor);
PBYTE SnapShot(cls1394HANDLE hDev);
PCHAR Yuv2DIB(char *YuvData);

#pragma pack(1)

typedef struct {
	BYTE  bfType[2];
	DWORD bfSize;
	WORD  bfReserved[2];
	DWORD bfOffBits;
	DWORD biSize;
	DWORD biWidth;
	DWORD biHeight;
	WORD  biPlanes;
	WORD  biBitCount;
	DWORD biCompression;
	DWORD biSizeImage;
	DWORD biXPelsPerMeter;
	DWORD biYPelsPerMeter;
	DWORD biClrUsed;
	DWORD biClrImportant;
} BMPHEAD;

#pragma pack()

